<?php
//if (!defined(PHPWG_ROOT_PATH)) die('Hacking attempt!');

global $user, $conf, $template;

// Check Access and exit when user status is not ok
check_status(ACCESS_ADMINISTRATOR);

$me = get_plugin_data($plugin_id);

load_language('plugin.lang', NBC_ThemeChanger_PATH);
$page_ThemeChanger_admin = get_admin_plugin_menu_link(__FILE__);



$cat=array();
$categories = array();


//chargement des catgories
 $query = '
    SELECT id, name, uppercats, global_rank
    FROM '.CATEGORIES_TABLE.' ;
  ';
   $result = pwg_query($query);

   while (($cat = mysql_fetch_array($result)) <> null)
   {
   array_push($categories , array("id" => $cat['id'],
				"name" => $cat['name'],
				"uppercats" =>$cat['uppercats'],
				"longName" => get_cat_display_name_cache($cat['uppercats'], null, false),
				"global_rank" => $cat['global_rank'],
				));
		}


//chargement des thmes
$themes = array();
foreach (get_pwg_themes() as $pwg_template)
{
	$selected = $pwg_template;
	array_push($themes, $selected);
}

// Configuration du template
$template->assign('params',
array(
    'U_HOME' => make_index_url(),
	'F_ACTION' => add_url_params($page_ThemeChanger_admin, array()),
    'U_ADD_ASSOC' => add_url_params($page_ThemeChanger_admin, array('action' => 'add_assoc')),
    'U_HELP' => PHPWG_ROOT_PATH.'popuphelp.php?page=ThemeChanger_admin',
	'Themes' => $themes,
	'Categories' => $categories,
));


// Mise a jour de la base de donnee
if (isset($_POST['submit']) and !is_adviser())
  if ( (isset($_POST['categorychoise']) or isset($_POST['category_id'])) and isset($_POST['template']) )
  {
    $conf_nbc_ThemeChanger = isset($conf['nbc_ThemeChanger']) ? explode(";" , $conf['nbc_ThemeChanger']) : array();

    $newconf_nbc_ThemeChanger = '';
    $theme = explode("/" , $_POST['template']);
    $add_ok = false;

    $thecategory = isset($_POST['categorychoise']) ? $_POST['categorychoise'] : ( isset($_POST['category_id']) ? $_POST['category_id'] : '');

    $_POST['categorychoise'] = '';
    $_POST['category_id'] = '';
    $_POST['template'] = '';
    $_GET['action'] = '';

    foreach ($conf_nbc_ThemeChanger as $Theme_Cat)
    {
      $element_ThemeChanger = explode("," , $Theme_Cat);

      if ($newconf_nbc_ThemeChanger <> '')
        $newconf_nbc_ThemeChanger .= ';';

      if ($element_ThemeChanger[0] == $thecategory)
      {
        $newconf_nbc_ThemeChanger .= $thecategory.','.$theme[0].','.$theme[1];
        $add_ok = true;
      }
      else if ($element_ThemeChanger[0] <> '')
      {
        $newconf_nbc_ThemeChanger .= $element_ThemeChanger[0].','.$element_ThemeChanger[1].','.$element_ThemeChanger[2];
      }
    }

    if ($add_ok == false)
    {
      if ($newconf_nbc_ThemeChanger <> '')
        $newconf_nbc_ThemeChanger .= ';';

      $newconf_nbc_ThemeChanger .= $thecategory.','.$theme[0].','.$theme[1];
    }

    $conf['nbc_ThemeChanger'] = $newconf_nbc_ThemeChanger;

    $query = '
      UPDATE '.CONFIG_TABLE.'
      SET value="'.$newconf_nbc_ThemeChanger.'"
      WHERE param="nbc_ThemeChanger"
      LIMIT 1';
    pwg_query($query);

    array_push($page['infos'], l10n('nbc_ThemeChanger_save_config'));
}



$conf_nbc_ThemeChanger = isset($conf['nbc_ThemeChanger']) ? explode(";" , $conf['nbc_ThemeChanger']) : array();

$catsused = array();
$assoc_ThemeChanger = array();

foreach ($conf_nbc_ThemeChanger as $Theme_Cat)
{
  $element_ThemeChanger = explode("," , $Theme_Cat);

  if ($element_ThemeChanger[0] <> '' and $element_ThemeChanger[1] <> '' and $element_ThemeChanger[2] <> '')
  {
    array_push($catsused, $element_ThemeChanger[0]);

    $query = '
      SELECT uppercats
        FROM '.CATEGORIES_TABLE.'
        WHERE id = \''.$element_ThemeChanger[0].'\'
      ;';

    $result = pwg_query($query);
    $row = mysql_fetch_array($result);

    $assoc_ThemeChanger[$element_ThemeChanger[0]] = array(
      'CATEGORY_NAME' => get_cat_display_name_cache($row['uppercats'], null, false),
      'TEMPLATE' => $element_ThemeChanger[1].'/'.$element_ThemeChanger[2],
    );
  }
}




//delete an association
if ( isset($_GET['action']) and ($_GET['action']=='del_assoc') and isset($_GET['id_cat']) and is_numeric($_GET['id_cat']) and !is_adviser() )
{
  $conf_nbc_ThemeChanger = isset($conf['nbc_ThemeChanger']) ? explode(";" , $conf['nbc_ThemeChanger']) : array();

  $newconf_nbc_ThemeChanger = '';

  foreach ($conf_nbc_ThemeChanger as $Theme_Cat)
  {
    $element_ThemeChanger = explode("," , $Theme_Cat);

    if ($element_ThemeChanger[0] <> $_GET['id_cat'] and $element_ThemeChanger[0] <> '')
    {
      if ($newconf_nbc_ThemeChanger <> '')
        $newconf_nbc_ThemeChanger .= ';';

      $newconf_nbc_ThemeChanger .= $element_ThemeChanger[0].','.$element_ThemeChanger[1].','.$element_ThemeChanger[2];
    }
  }

  $conf['nbc_ThemeChanger'] = $newconf_nbc_ThemeChanger;

  $query = '
    UPDATE '.CONFIG_TABLE.'
    SET value="'.$newconf_nbc_ThemeChanger.'"
    WHERE param="nbc_ThemeChanger"
    LIMIT 1';
  pwg_query($query);

  array_push($page['infos'], l10n('nbc_ThemeChanger_save_config'));
}

//modify an association
else if ( isset($_GET['action']) and ($_GET['action']=='mod_assoc') and isset($_GET['id_cat']) and is_numeric($_GET['id_cat']) )
{
  $template->assign('formulaire',array(
    'DESCRIPION' => $lang['modify_assoc'].' : '.$assoc_ThemeChanger[$_GET['id_cat']]['CATEGORY_NAME'],
    'NAMETOMODIFY' => $assoc_ThemeChanger[$_GET['id_cat']]['CATEGORY_NAME'],
    'IDTOMODIFY' => $_GET['id_cat'],
  ));
	
  $template->assign('formulaire.categoryfield', array(
    'NAME' => $assoc_ThemeChanger[$_GET['id_cat']]['CATEGORY_NAME'],
    'ID' => $_GET['id_cat'],
  ));

  $blockname = 'formulaire.template_option';

  foreach (get_pwg_themes() as $pwg_template)
  {
    if ($assoc_ThemeChanger[$_GET['id_cat']]['TEMPLATE'] == $pwg_template)
    {
      $selected = 'selected="selected"';
    }
    else
    {
      $selected = '';
    }
	
	$template->assign(
      $blockname,
      array(
        'VALUE'=> $pwg_template,
        'CONTENT' => $pwg_template,
        'SELECTED' => $selected
        ));
  }
}

//add an association
else if ( isset($_GET['action']) and ($_GET['action']=='add_assoc') )
{
	//$template->assign_var('formulaire',array(
	$template->assign(
		'formulaire',
		array('DESCRIPION' => $lang['add_assoc'],
		)
	);

	$template->assign('formulaire.categorylist', array());
	$blockname = 'formulaire.categorylist.parent_option';

  $template->assign($blockname, array());


  $query = '
    SELECT id, name, uppercats, global_rank
    FROM '.CATEGORIES_TABLE.'
  ';
  if (!empty($catsused))
  {
    $query .= '
      WHERE id NOT IN ('.implode(',', $catsused).')
    ';
  }
  $query .= ' ;';
  display_select_cat_wrapper($query, array(), $blockname);

  $blockname = 'formulaire.template_option';

  foreach (get_pwg_themes() as $pwg_template)
  {
	$template->assign(
      $blockname,
      array(
        'VALUE'=> $pwg_template,
        'CONTENT' => $pwg_template,
        'SELECTED' => '',
      )
    );
  }
}

$conf_nbc_ThemeChanger = isset($conf['nbc_ThemeChanger']) ? explode(";" , $conf['nbc_ThemeChanger']) : array();

$num = 0;
$catsused = array();
$assoc_ThemeChanger = array();
$assoc = array();

foreach ($conf_nbc_ThemeChanger as $Theme_Cat)
{
  $element_ThemeChanger = explode("," , $Theme_Cat);

  if ($element_ThemeChanger[0] <> '' and $element_ThemeChanger[1] <> '' and $element_ThemeChanger[2] <> '')
  {
    array_push($catsused, $element_ThemeChanger[0]);

    $query = '
      SELECT uppercats
        FROM '.CATEGORIES_TABLE.'
        WHERE id = \''.$element_ThemeChanger[0].'\'
      ;';

    $result = pwg_query($query);
    $row = mysql_fetch_array($result);

     array_push($assoc , array(
        'CLASS' => ($num++ % 2 == 1) ? 'row2' : 'row1',
        'CATEGORY_NAME' => get_cat_display_name_cache($row['uppercats'], null, false),
        'CATEGORY_ID'   => $element_ThemeChanger[0],
        'TEMPLATE' => $element_ThemeChanger[1].'/'.$element_ThemeChanger[2],
        'U_MODIFY'      => add_url_params($page_ThemeChanger_admin, array(
          'action' => 'mod_assoc',
          'id_cat' => $element_ThemeChanger[0],
          )),
        'U_DELETE'      => add_url_params($page_ThemeChanger_admin, array(
          'action' => 'del_assoc',
          'id_cat' => $element_ThemeChanger[0],
          )),));

    $assoc_ThemeChanger[$element_ThemeChanger[0]] = array(
      'CATEGORY_NAME' => get_cat_display_name_cache($row['uppercats'], null, false),
      'TEMPLATE' => $element_ThemeChanger[1].'/'.$element_ThemeChanger[2],
    );
  }
}
$template->assign(
      'assoc',$assoc );


//  template initialization
$template->set_filenames(array('plugin_admin_content' => dirname(__FILE__).'/nbc_ThemeChanger_admin.tpl'));
$template->assign_var_from_handle( 'ADMIN_CONTENT', 'plugin_admin_content');

?>